package metrics;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.function.Function;

import io.vavr.Tuple2;
import io.vavr.collection.IndexedSeq;
import metrics.structures.CostAndInstedGI;
import metrics.structures.MetricTypeGI;

public  class MetricCollectionGIAsyn<S> {

	//pripravena vlakna
	protected static ExecutorService executor = Executors.newFixedThreadPool(5);
		
	/**
	 * vypocet ve vlaknu
	 * pocita metriku rychle
	 * @param input
	 * @param type
	 * @return
	 * @throws InterruptedException
	 */
	public Future<MetricCollectionGIQuick<S>> calculateQuick(
			final IndexedSeq<Tuple2<IndexedSeq<S>, IndexedSeq<S>>> input, 
			final MetricTypeGI type) throws InterruptedException {
	     return executor.submit(
	    		   ()->new MetricCollectionGIQuick<S>(input, type));	
	}
	
	/**
	 * vypocet ve vlaknu
	 * pocita metriku s detailem
	 * @param input
	 * @param type
	 * @param ci
	 * @return
	 * @throws InterruptedException
	 */
	public Future<MetricCollectionGIInfo<S>> calculateInfo(
			final IndexedSeq<Tuple2<IndexedSeq<S>, IndexedSeq<S>>> input,
			final MetricTypeGI type,
			final CostAndInstedGI<S> ci,
			final Function<String, String> translator)throws InterruptedException {
		return executor.submit(()->new MetricCollectionGIInfo<S>(input, type, ci, translator));	
	}
}
