package metrics.metric;
import java.util.Optional;

import io.vavr.collection.IndexedSeq;
import metrics.metricquick.MetricGIQuick;

/**
 * interface pro metriky
 * @author Ondej Nmec
 *
 * @param <T> - typ struktury
 * @param <S> - typ vstupnich dat
 */
public interface MetricGIInfo<T, S> extends MetricGIQuick<S> {//T - typ struktury, N - typ sla, S typ vstupnich dat

	/**
	 * ziskani upravene prvni hodnoty
	 * @return
	 */
	public Optional<IndexedSeq<S>> getFinalFrom();
	
	/**
	 * ziskani upravene druhe hodnoty
	 * @return
	 */
	public Optional<IndexedSeq<S>> getFinalTo();
	
	/**
	 * ziskani struktury
	 * @return
	 */
	public Optional<T> getStructure();
	
	/**
	 * vytvory slovni popis probehlych akci
	 * @return
	 */
	public Optional<String> getFormatedText();
	
	/**
	 * vraci vazenou hodnotu distance
	 * podle nastavene hodnoty v costandinsted
	 * @return
	 */
	public Optional<Number> getWeightDistance();
	
}
