package metrics.metric;

import java.util.Optional;

import io.vavr.Tuple2;
import io.vavr.collection.IndexedSeq;
import metrics.structures.MatrixGI;

/**
 * interface pro metriky se strukturou matice
 * @author Ondej Nmec
 *
 * @param <R> typ bunky v matici
 */
public interface StructureMatrixGI<R, S> extends MetricGIInfo<MatrixGI<R>,S> {

	/**
	 * seznam hodnot pro specialni obarveni v matici
	 * @return
	 */
	public Optional<IndexedSeq<Tuple2<Integer, Integer>>> getIndexes();
	
	/**
	 * posunuti - podle typu matice - jak daleko od zacatku radku ma zacit slovo
	 * @return
	 */
	public int getShift();
	
	/**
	 * z T dostane patricnou hodnotu pro zobrazeni
	 * @param origin
	 * @return
	 */
	public String getValue(final R origin);
	
	
}
