package metrics.metricquick;

import java.util.Optional;

import io.vavr.collection.IndexedSeq;
import metrics.structures.MetricError;

/**
 * 
 * @author Ondej Nmec
 *
 * @param <N> - typ cisla
 * @param <S> - typ vstupnich dat
 */
public interface MetricGIQuick<S> {
	
	/**
	 * vraci prvni vstupni hodnotu
	 * @return
	 */
	public Optional<IndexedSeq<S>> getFrom();
	
	/**
	 * vraci druhou vstupni hodnotu
	 * @return
	 */
	public Optional<IndexedSeq<S>> getTo();
	
	/**
	 * vraci vypoctenou vzdalenost
	 * @return
	 */
	public Optional<Number> getDistance();

	/**
	 * vraci informace o probehlem vypoctu
	 * @return
	 */
	public MetricError getError();
}
