package metrics.structures;

import java.util.function.Function;

/**
 * trida pro upravu textu a ceny operaci
 * @author Ondej Nmec
 *
 * @param <S>
 */
public class CostAndInstedGI<S> {

	private final Function<Character, S> deletion;
	private final Function<Character, S> insertion;
	private final Function<S, S> transposition;
	private final Function<S, S> substitution;
	
	private final Number deletionCost;
	private final Number insertionCost;
	private final Number transpositionCost;
	private final Number substitutionCost;
	
	public CostAndInstedGI(
			final Function<Character, S> deletion,
			final Function<Character, S> insertion,
			final Function<S, S> transposition,
			final Function<S, S> substitution,
			final Number deletionCost,
			final Number insertionCost,
			final Number transpositionCost,
			final Number substitutionCost) {
		this.deletion = deletion;
		this.insertion = insertion;
		this.transposition = transposition;
		this.substitution = substitution;
		this.deletionCost = deletionCost;
		this.insertionCost = insertionCost;
		this.transpositionCost = transpositionCost;
		this.substitutionCost = substitutionCost;
		
	}

	public final Function<Character, S> getDeletion() {
		return deletion;
	}

	public final Function<Character, S> getInsertion() {
		return insertion;
	}

	public final Function<S, S> getTransposition() {
		return transposition;
	}

	public final Function<S, S> getSubstitution() {
		return substitution;
	}

	public final Number getDeletionCost() {
		return deletionCost;
	}

	public final Number getInsertionCost() {
		return insertionCost;
	}

	public final Number getTranspositionCost() {
		return transpositionCost;
	}

	public final Number getSubstitutionCost() {
		return substitutionCost;
	}
	
	
}
