

import java.util.Locale;

import javax.swing.JOptionPane;

import dnarna.base.Nucleotid;
import gui.Main;
import lang.Lang;
import musicnotes.mark.Mark;
import structure.character.CharacterStructure;
import structure.dna.DnaStructure;
import structure.musicnotes.MusicnotesStructure;

public class RunKVSO {
	
	public static void main(String[] e) {
		
		 class GIObjeckt{
			String name;
			String description;
			public GIObjeckt(String name, String desc) {
				this.name = name;
				this.description = desc;
			}
			@Override
			public String toString() {
				return description;
			}
		}

		 String[] languages = {"čeština", "english", "русский"};
			
		String langOpt = (String)JOptionPane.showInputDialog(
				null,
				"",
				"",
				JOptionPane.QUESTION_MESSAGE,
				null,
				languages,
				null
				);
		if(langOpt!=null)
			switch (langOpt) {
			case "čeština":
				Locale.setDefault(new Locale("cs"));
				break;
			case "english":
				//Locale.setDefault(Locale.UK);
				Locale.setDefault(new Locale("en"));
				break;
			case "русский":
				Locale.setDefault(new Locale("ru"));
				break;
			default:
				break;
			}
		 
		GIObjeckt[] opt = {
				//"Znaky - pismena, cislice,..."
				new GIObjeckt("character", Lang.getMessage("run.selectObject.character")), 
				//"Noty"
				new GIObjeckt("note", Lang.getMessage("run.selectObject.note")), 
				//"DNA/RNA"
				new GIObjeckt("dna", Lang.getMessage("run.selectObject.dna")) 
			};
		GIObjeckt gi = (GIObjeckt)JOptionPane.showInputDialog(
				null,
				//"Zvolte, co chcete porovnavat"
				Lang.getMessage("run.selectObject.message"), 
				//"Druh objektu"
				Lang.getMessage("run.selectObject.title"),  
				JOptionPane.QUESTION_MESSAGE,
				null,
				opt,
				null
				);

		if(gi!=null)
			switch (gi.name) {
			case "character":
				Main<Character> charM = new Main<>(new CharacterStructure());
				charM.setVisible(true);
				break;
			case "note":
				Main<Mark> noteM = new Main<>( new MusicnotesStructure());
				noteM.setVisible(true);
				break;
			case "dna":
				Main<Nucleotid> nucM = new Main<>(new DnaStructure());
				nucM.setVisible(true);
				break;
			default:
				JOptionPane.showMessageDialog(
						null,
						//"Tento typ objektu neni podporovan"
						Lang.getMessage("run.error.message"), 
						//"Chyba"
						Lang.getMessage("run.error.title"),  
						JOptionPane.ERROR_MESSAGE);
				System.err.println("Nelze vybrat spravny S: " + gi.name);
				System.exit(0);
				break;
			}
		
		}
	
}
