package gui;

import java.awt.BorderLayout;
import java.awt.Font;
import java.util.Optional;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import gui.viewer.TableRenderer;
import io.vavr.collection.Array;

public class Internal extends JInternalFrame {
	private static final long serialVersionUID = 1L;
	private InternalName name;
	
	private Optional<AbstractTableModel> tableModel;
	private Optional<JTable> table;
	private Optional<TableRenderer> renderer;
	

	public Internal(final String name, final InternalName interName,
					final JComponent content,
					final int width, final int height,
					final Icon icon) {
		super(name, true, true, true, true);
		setSize(width, height);
		setFrameIcon(icon);
		add(content, BorderLayout.CENTER);
		
		this.tableModel = Optional.empty();
		this.table = Optional.empty();
		this.renderer = Optional.empty();
		this.name = interName;
		show();
	}
	
	public Internal(final String name, InternalName interName,
					final AbstractTableModel tableModel, final TableRenderer renderer,
					final int width, final int height,
					final Icon icon) {
		super(name, true, true, true, true);
		setFrameIcon(icon);
		setSize(width, height);
		this.renderer = Optional.of(renderer);
		
		this.tableModel = Optional.of(tableModel);
		this.table = Optional.of(new JTable(tableModel));
		table.get().setDefaultRenderer(Array.class, renderer);
		
		this.name = interName;
		add(new JScrollPane(table.get()));
		
		show();
	}
	
	/*****/
	public void setValueSize(final int koef){
		if(!table.equals(Optional.empty())){
			table.get().setFont(new Font("Arial", Font.PLAIN, koef));
			renderer.get().setSize(koef);
			table.get().setRowHeight(renderer.get().getDefaultRowHeight() + koef);
			table.get().repaint();
		}
		
	}
	
	public Optional<AbstractTableModel> getTableModel(){
		return tableModel;
	}
	
	
	public void setTableModel(final AbstractTableModel model){
		if(!table.equals(Optional.empty())){
			this.tableModel = Optional.of(model);
			table.get().setModel(model);
			table.get().repaint();
		}
		
	}
	
	public InternalName getInternalName(){
		return name;
	}
	public int getSelectedRow(){
		if(table.equals(Optional.empty()))
			return -1;
		return table.get().getSelectedRow();
	}


}
