package structure.character;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.function.Function;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JTable;

import gui.viewer.TableEditor;
import io.vavr.collection.Array;
import io.vavr.collection.IndexedSeq;
import lang.Lang;

public class CharacterCellEditor extends TableEditor {
	private static final long serialVersionUID = 1L;
	
	private final Function<String, IndexedSeq<Character>> fromStringToSeq;
	private final Function<IndexedSeq<Character>, String> fromSeqToString;
	
	private IndexedSeq<Character> current;
	private JButton button;
	protected static final String EDIT = "Vlozit";

	public CharacterCellEditor(
			 final Function<String, IndexedSeq<Character>> fromStringToSeq,
			 final Function<IndexedSeq<Character>, String> fromSeqToString) {
		this.fromStringToSeq = fromStringToSeq;
		this.fromSeqToString = fromSeqToString;
		
		this.current = Array.empty();
		this.button = new JButton();
		button.setActionCommand(EDIT);
		button.addActionListener(this);
		button.setBorderPainted(false);
		
	}
	
	@Override
	public Object getCellEditorValue() {
		if(current == null)
			return Array.empty();
		return current;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		final String value =JOptionPane.showInputDialog(
					button, Lang.getMessage("chEditor.fillWord"), //"Zadejte slovo",
					fromSeqToString.apply(current));
		if(EDIT.equals(e.getActionCommand())){
			if(value != null)
				current = fromStringToSeq.apply(value);
			fireEditingStopped();
		}else{
			if(value != null)
				current = fromStringToSeq.apply(value);
		}
		
	}

	@SuppressWarnings("unchecked")
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
		current = (IndexedSeq<Character>)value;
		return button;
	}

	

}
