package structure.musicnotes;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.List;
import java.util.function.Function;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;

import gui.viewer.Editor;
import gui.viewer.TableEditor;
import io.vavr.collection.Array;
import io.vavr.collection.IndexedSeq;
import lang.Lang;
import musicnotes.mark.Mark;

public class MusicnotesCellEditor extends TableEditor {

	private static final long serialVersionUID = 1L;
	
	private final Function<Mark, Component> fromSToComp;
	
	private IndexedSeq<Mark> current;
	private JButton button;
	protected static final String EDIT = "Vlozit";	
	
	public MusicnotesCellEditor(final Function<Mark, Component> fromSToComp) {
		this.fromSToComp = fromSToComp;
		
		this.current = Array.empty();
		this.button = new JButton();
		button.setActionCommand(EDIT);
		button.addActionListener(this);
		button.setBorderPainted(false);
	}
	
	
	

	@Override
	public Object getCellEditorValue() {
		if(current == null)
			return Array.empty();
		return current;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Editor<Mark> edit = new Editor<>(current, fromSToComp);
		if(EDIT.equals(e.getActionCommand())){
			current = edit.getInput(buttons(edit.add()));
			fireEditingStopped();
		}else{
			current = edit.getInput(buttons(edit.add()));
		}
		
	}

	@SuppressWarnings("unchecked")
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
		table.setRowHeight(60);
		current = (IndexedSeq<Mark>)value;
		return button;
	}
	
	//TODO zadavani
	private JPanel buttons(final Function<Mark, List<Mark>> add){
		JPanel result = new JPanel();
		
		JLabel label = new JLabel(Lang.getMessage("music.editor.notSupport"));
		result.add(label);
		/*
		JButton pauseQuarter = new JButton("quarter");
		pauseQuarter.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				add.apply(new Pause(Time.QUARTER));
				
			}
		});
		JButton pauseFull = new JButton("full");
		pauseFull.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				add.apply(new Pause(Time.FULL));
				
			}
		});
		JButton pauseHalf = new JButton("half");
		pauseHalf.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				add.apply(new Pause(Time.HALF));
				
			}
		});
		JButton pauseEight = new JButton("eidg");
		pauseEight.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				add.apply(new Pause(Time.EIGHTH));
				
			}
		});
		
		result.add(pauseFull);
		result.add(pauseHalf);
		result.add(pauseQuarter);
		result.add(pauseEight);
		*/
		return result;
	}

	
	

}
