package tbl.model;

import javax.swing.table.AbstractTableModel;

import io.vavr.collection.Array;

import io.vavr.Tuple3;
import io.vavr.collection.IndexedSeq;
import lang.Lang;

public class CalculateData<S> extends AbstractTableModel {
	private static final long serialVersionUID = 1L;
	private final IndexedSeq<Tuple3<IndexedSeq<S>, IndexedSeq<S>, Number>> triples;
	
	public CalculateData(final IndexedSeq<Tuple3<IndexedSeq<S>, IndexedSeq<S>, Number>> triples) {
		this.triples = triples;		
	}

	@Override
	public int getColumnCount() {
		return 3;
	}

	@Override
	public int getRowCount() {
		return triples.size();
	}
	
	@Override
	public Object getValueAt(final int row,final int column) {
		switch(column){
		case 0: return triples.get(row)._1;  
		case 1: return triples.get(row)._2;
		case 2: return triples.get(row)._3;
		}
		this.fireTableCellUpdated(row, column);
		return "";
	}
	
	@Override
	public String getColumnName(final int column) {
		switch (column){
		case 0: return Lang.getMessage("calculate.firstRow");
		case 1: return Lang.getMessage("calculate.secondRow");
		case 2: return Lang.getMessage("calculate.thirdRow");
		
		default: return "";
		}
	}
	
	@Override
	public Class<?> getColumnClass(int column) {
		switch (column) {
		case 0: return Array.class;
		case 1: return Array.class;
		case 2: return Number.class;
		default: return Object.class;
		}
	}
	

	@Override
	public boolean isCellEditable(final int row, final int column) {
		return false;
	}
	
	public IndexedSeq<Tuple3<IndexedSeq<S>, IndexedSeq<S>, Number>>  getTriples(){
		return triples;
	}
	
	

}
