package tbl.reworker;

import java.util.Optional;

import io.vavr.Tuple2;
import io.vavr.Tuple3;
import io.vavr.collection.IndexedSeq;

public interface Reworker<S, I> {
	
	public Optional<IndexedSeq<Tuple2<IndexedSeq<S>, IndexedSeq<S>>>> 
			reworkInput(final Optional<I> object);
	
	public I reworkOrigin(
			final IndexedSeq<Tuple2<IndexedSeq<S>, IndexedSeq<S>>> seq);
	
	public I reworkCalculate(
			final IndexedSeq<Tuple3<IndexedSeq<S>, IndexedSeq<S>, Number>> seq);
	
	public I reworkEntrophyOveral(
			final IndexedSeq<IndexedSeq<String>> seq);
	
	public I reworkEntrophyTwins(
			final IndexedSeq<Tuple2<S,Number>> seq);
	
	public I reworkEntrophyTriples(
			final IndexedSeq<Tuple3<S, S,Number>> seq);
}
