package musicnotes.mark;

import io.vavr.collection.IndexedSeq;
import io.vavr.collection.Stream;

public class Accord implements Mark {
	
	private IndexedSeq<Note> mark;
	
	public Accord(final IndexedSeq<Note> mark) {
		this.mark = mark;
	}
	
	/*******************************/
	@Override
	public String toString() {
		return "{"
				+ Stream.range(0, mark.size()).foldLeft("",
						(curr, i )->curr+mark.get(i).toString())				
				+ "}";
	}
	
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof Accord){
			Accord ac = (Accord)obj;
			if(mark.size() != ac.getMark().size())
				return false;
			return Stream.range(0, mark.size()).foldLeft(false,
					(curr,i)->{
						return mark.get(i).equals(ac.getMark().get(i));
					});
		}
		return false;
	}
	
	/*******************************/
	public IndexedSeq<Note> getMark(){
		return mark;
	}

}
