package musicnotes.mark;

import musicnotes.mark.enums.Time;

public class Pause implements Mark{
	private Time time;
	
	public Pause(final Time time) {
		this.time = time;
	}
	
	/******************/
	
	@Override
	public String toString() {
		return "{" + switchTime(this.time) + "}";
	}
	
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof Pause){
			return time == ((Pause)obj).getTime();
		}
		return false;
	}
	
	/******************/
	public Time getTime(){
		return time;
	}
	
	/*****************/
	
	private String switchTime(final Time time){
		switch (time) {
		case FULL:
			return "(1)";
		case HALF:
			return "(1/2)";
		case QUARTER:
			return "(1/4)";
		case EIGHTH:
			return "(1/8)";
		case SIXTEENTH:
			return "(1/16)";
		case THREETHYHT:
			return "(1/32)";
		default:
			return "";
		}
	}

}
