package dnarna;

import dnarna.base.NitroBase;
import dnarna.base.Nucleotid;
import io.vavr.Tuple2;
import io.vavr.collection.Array;
import io.vavr.collection.IndexedSeq;
import io.vavr.collection.Stream;

public class DNA 
	implements NucleotidSequence<Tuple2<IndexedSeq<Nucleotid>, IndexedSeq<Nucleotid>>> {

	private final IndexedSeq<Nucleotid> first;
	
	private final IndexedSeq<Nucleotid> second;
	
	
	public DNA(final IndexedSeq<Nucleotid> thread) {
		this.first = Stream.range(0, thread.size()).foldLeft(Array.empty(),
				(curr, i)->{
					if(thread.get(i).getBase()==NitroBase.URACIL)
						return curr.append(new Nucleotid(NitroBase.THYMIN));
					return curr.append(thread.get(i));
				});
		this.second = Stream.range(0, first.size()).foldLeft(Array.empty(),
				(curr, i)->{
					switch (first.get(i).getBase()) {
					case THYMIN:
						return curr.append( new Nucleotid(NitroBase.ADENIN));
					case ADENIN:
						return curr.append( new Nucleotid(NitroBase.THYMIN));
					case GVANIN:
						return curr.append( new Nucleotid(NitroBase.CYTOZIN));
					case CYTOZIN:
						return curr.append( new Nucleotid(NitroBase.GVANIN));
					default:
						return curr;
					}
				});
		
	}
	
	
	@Override
	public Tuple2<IndexedSeq<Nucleotid>, IndexedSeq<Nucleotid>> getThread() {
		return new Tuple2<>(first, second);
	}

	@Override
	public IndexedSeq<Nucleotid> makeCopy() {
		return second;
	}

}
