package dnarna;

import dnarna.base.NitroBase;
import dnarna.base.Nucleotid;
import io.vavr.collection.Array;
import io.vavr.collection.IndexedSeq;
import io.vavr.collection.Stream;

public class RNA implements NucleotidSequence<IndexedSeq<Nucleotid>>{
	
	private final IndexedSeq<Nucleotid> thread;
	
	public RNA(final IndexedSeq<Nucleotid> thread) {
		this.thread = Stream.range(0, thread.size()).foldLeft(Array.empty(),
				(curr, i)->{
					if(thread.get(i).getBase()==NitroBase.THYMIN)
						return curr.append(new Nucleotid(NitroBase.URACIL));
					return curr.append(thread.get(i));
				});
	}
	
	
	
	@Override
	public IndexedSeq<Nucleotid> getThread() {
		return thread;
	}

	@Override
	public IndexedSeq<Nucleotid> makeCopy() {
		return Stream.range(0, thread.size()).foldLeft(Array.empty(),
				(curr, i)->{
					switch (thread.get(i).getBase()) {
					case URACIL:
						return curr.append( new Nucleotid(NitroBase.ADENIN));
					case ADENIN:
						return curr.append( new Nucleotid(NitroBase.URACIL));
					case GVANIN:
						return curr.append( new Nucleotid(NitroBase.CYTOZIN));
					case CYTOZIN:
						return curr.append( new Nucleotid(NitroBase.GVANIN));
					default:
						return curr;
					}
				});
	}

}
